CraftBuster
===========

Has this happened to you?
"Oh, hey! Earthroot! ...Wait, what do you mean 'Requires Level 15'?! How the heck was I supposed to know that?"
How about:
"Man, it sure would be nice to know when I can learn the next rank of this profession..."
Or what even:
"Grah! Why isn't there something to list all the stuff I can mill/prospect/disenchant/lock pick?!"

If so, then you're in luck!

With this handy, dandy addon you'll have access to so much for your professions you won't believe you lived without it for so long!

Features include:
-----------------
* Herb and mining nodes list when the node goes Orange, Yellow, Green, and Grey. Skinning does this as well, but the calculations are done manually and may not be completely accurate at the moment.
* After mining, herbing, or skinning (and not in combat), it will display when certain other nodes reach a new gathering state. Example: if you gather enough peacebloom to be able to start gathering earthroot, it will inform you earthroot turned orange. Likewise, if you are at the correct player level and skill level it will inform you to visit your trainer. Please note: initial loading of a high level character (or resetting character data) will spam you with the ALL available information as it goes through them.
* A frame listing all your professions, including your current profession level (including any skill buffs), your max level, icons related to that profession (such as the camp fire for cooking), and certain professions have a special button for 'buster' functionality. Rogues will also have a frame for their lock picking skill.
* The skill frame can also be collapsed so just the header remains, and clicking on the X button will close it completely. There is a minimap menu toggle in case you need to display it again
* Normally, the skill frame has a green background for each of the professions. However, if the background for a profession is **red**, that means you are able to learn the next profession level and should do so soon before you start wasting skillups. If the background is **blue**, that means you're nearing the skillup cap but haven't leveled to the point you'll need to.
* Buster functionality: Clicking on a 'buster' icon in the skill frame will display a frame that lists all of the relevant items that are currently in your bags. If you have more than 5 of an herb or ore in your bags, it will be listed. If you are a **rogue** with Lock Picking, it will list all of the lockboxes in your bags. If you are an **enchanter**, this will list all the green or better quality items that can be disenchanted in your bags. It will not display items equipped and it will not disenchant them, either. However, keep in mind that once you've disenchanted the item it is still gone, so if you accidentally DE something you shouldn't have then it's on you.
* Ignore Item functionality: In the buster frame, if you CTRL + Right click an item, it will hide that item. Note: It hides based off of name/item id and NOT that specific item. If you have a bunch of Iron Lockboxes in your bags and you tell it to ignore one of them, it will ignore all of them. Currently the only way to undo the hidden is with a key command.
* Like the skill frame, the buster frame can also be collapsed, but generally it's better to just close the window.
* Inks show what pigments and herbs are needed to make that ink, pigments list what herbs that pigment is milled from and what inks can be made from that pigment, and herbs list what pigments they mill to and what inks can be made from the pigments of that herb.
* BETA: A button in the Enchanting frame is added when you have Enchanting Vellums in your inventory and have an appropriate enchant selected.

Shortcut Keys:
--------------
* /cb (or /craftbuster or /cbuster) reset - Reset an individual characters settings completely
* /cb config - Open the config menu
* /cb fullreset - Clear out and Reset the settings for all characters on a given account/server
* /cb clearignore - Reset all items ignored on a given character
* /cb update - Force an update of a character's skills

Future functionalities:
-----------------------
* Displaying items that have been hidden and allowing for undo manually
* Alerting you of skinnable mobs if you're a skinner after you kill them.
* Item grouping for buster functionality. Currently the UI requires groupings of 5 or more in order for milling/prospecting to function properly. But if you have a stack of 3 and another stack of 17, generally the buster functionality will only notice the stack of 3 (depending on its ordering in the bags). So, for the time being you will have to do this manually.
* Remove recently unlocked lockboxes from Lock Picking buster frame
* Possibly add tooltip information to skill frame when you're able to learn or under leveled to learn next profession rank.

Known Bugs:
-----------
* Skinnable mobs don't calculate properly since Mists.
* Generally most of the skill level-related functionality is hard-coded, meaning I have to find it out myself and plug it in manually. So if you find different levels than what is listed, please tell me.
* Low-level characters & new professions are a bit glitchy when first learned. "/cb reset" usually clears it up, but this is not ideal
* Config menu, though I'm not sure what all for.
* Attempting to hide/show the skill frame while in combat is currently disabled.

Author's notes:
---------------
I started this mod quite a while ago, adding bits here and there as I could. For the most part it's pretty much solid in what I wanted it to do and what I've yet to add to. That said, if you find anything significantly lacking in this mod, feel free to shoot me a message for feature requests.
However, keep in mind there are some things that I don't plan on adding to this mod. Things I don't plan on adding are rebuilding the profession UI, auction house integration, and prospecting result tabulation. This mod is more informational that an uber-functionality powerhouse.
